<?php
namespace Teknisa\CTB\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\CTB\Services\Ctb22000RelatorioRazaoOficialServices;

class  Ctb22000RelatorioRazaoOficialController{
    protected $reportService;
    protected $dataSourceManager;
    protected $nrorg;
    protected $execRazaoOficial;

    public function __construct(ReportService $reportService, $dataSourceManager, $environment, Ctb22000RelatorioRazaoOficialServices $execRazaoOficial) {
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        $this->nrorg = $environment->getNrorgTrab();
        $this->Ctb22000RelatorioRazaoOficialServices = $execRazaoOficial;
    }
    
    
    public function executaProcedureRazaoOficial(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $retornoProcedure = $this->Ctb22000RelatorioRazaoOficialServices->executaProcedureRazaoOficial($row);
            $response->addDataSet(new DataSet('Razao', ['P_NRRAZAO' => $retornoProcedure]));
        }catch(\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function generateReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $reportName = $row["__report_name"];
        $parametersRow = array (
            "NRRAZAO" => $row["NRRAZAO"],
            "DTINICIAL" => $row["DTINICIAL"] ,
            "DTFINAL" =>  $row["DTFINAL"],
            "NRORG" =>  $this->nrorg,
            "__format" => $row["__FORMAT"]
        );
        
        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        $response->addMessage(new DTO\Response\Message($birtURL));
    }
}