<?php

namespace Teknisa\CTB\Controllers;

use Doctrine\ORM\EntityManager;
use Teknisa\CTB\Services\Ctb89000PreValidacaoEcdService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;

class Ctb89000PreValidacaoEcdController {
    
    protected $preValidacaoEcdService;
    
    public function __construct(EntityManager $entityManager, Ctb89000PreValidacaoEcdService $preValidacaoEcdService) {
        $this->entityManager      = $entityManager;
        $this->PreValidacaoEcdService = $preValidacaoEcdService;
    }
        
    public function executaProcedurePreValidacaoEcd(Row $row, Response $response)
    {
        try {
            $rows = $row->getRow();
           
             $retorno = $this->PreValidacaoEcdService->executaProcedure($rows);
             $response->addDataSet(new DataSet('retorno', [$retorno]));
            
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    

    
}