<?php
namespace Teknisa\CTB\Controllers;

use Teknisa\CTB\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class ctb53100DemonstracoesContabeisController  extends TeknisaCrud {

	protected $crudService;
	protected $dataSourceName;
    protected $parameterBag;
    protected $DemonstracaoService;

    public function __construct($crudService, $parameterBag, $DemonstracaoService) {
		$this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->DemonstracaoService = $DemonstracaoService;
        $this->dataSourceName = 'itensestrutura';
        $this->dataSourceNameToSave = "itemdemof";
 	}
 	
 	public function findItemdemof(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $this->dataSourceName = 'itensestrutura';
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
            $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, array());
            $this->crudService->find($response, $newFilterCriteria);
            $rows = $response->getDataSets()[0]->getRows() ;
            $rows = $this->replaceWhiteSpace($rows, 'NMITEMSTRU');
            $dataSet = new DataSet( $this->dataSourceName, $rows);
            $response->setDataSets(array($dataSet));
            
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
 	}
 	
 	// substitui espaços pelo caracter especial vazio para que o zeedhi consiga reconhece-los no grid 
 	private function replaceWhiteSpace ($rows , $index){
 	    foreach($rows as &$row){
 	        $row[$index] = str_replace(' ', ' ', $row[$index]);
 	    }
 	    return $rows;
 	}
 	
 	
 	public function geraRelatorio(DTO\Request\Row $request, DTO\Response $response){
 	    $row = $request->getRow();
        
        //Chama a procedure que gerara dados para o relatorio
        $this->DemonstracaoService->callProcedureDemonstrativoCTBO($row);
        
        $reportName = 'ctb53100';

        $birtURL = $this->DemonstracaoService->montaRelatorio($reportName, $row);
        $response->addDataset(new DataSet('URL',array($birtURL)));
 	}
}