<?php
namespace Teknisa\CTB\Factories;

use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Doctrine\ORM\EntityManager;
use Teknisa\Model\Contabilidade\Listeners\Ctbtemp;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class ctb00003conciliacaofornecedoresxclientesFactory extends \Teknisa\CTB\Controllers\TeknisaCrud {

    protected $entityManager;
	protected $reportService;
	protected $connection;
	protected $environment;
    

   public function __construct($entityManager, $reportService,$environment) {
		$this->entityManager  = $entityManager;
        $this->reportService = $reportService;
        $this->connection    = $entityManager->getConnection();
        $this->environment = $environment;
 	}
 	
 	
 	 public function executaProcedureFactory($cdempresa, $datainic, $datafim, $nrctbtemp,$cdcontcome, $cdcontini, $cdcontfin) {
      //   var_dump($datainic); die;
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_RAZAO_PROV');
            $procedure->addParam(new Param('P_CDEMPRESA',       Param::PARAM_INPUT,     $cdempresa,         Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DATAINIC',        Param::PARAM_INPUT,     $datainic,          Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DATAFIM',         Param::PARAM_INPUT,     $datafim,           Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRCTBTEMP',       Param::PARAM_INPUT,     $nrctbtemp,         Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDSALD',          Param::PARAM_INPUT,     null,               Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCONTCOME',      Param::PARAM_INPUT,     $cdcontcome,        Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCONTINI',       Param::PARAM_INPUT,     $cdcontini,         Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCONTFIN',       Param::PARAM_INPUT,     $cdcontfin,         Param::PARAM_TYPE_STR));
            
            $this->connection->commit();
            $procedure->execute();
            
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    
    public function insereConciliacao($nrorg, $nrctbtemp, $idpart, $documento){
        // Query a ser executada.
        try{
            $sql = "UPDATE CTBTEMP SET IDCONCILIADO = 'S' WHERE IDPART = :IDPART AND NRCTBTEMP = :NRCTBTEMP AND NRORG =:NRORG AND CDDOCUCONTT = :CDDOCUCONTT" ;
        
            $params = array();
            $params['NRORG']   = $nrorg;
            $params['NRCTBTEMP']    = $nrctbtemp;
            $params['IDPART']   = $idpart;
            $params['CDDOCUCONTT']   = $documento;
            
            $statement = $this->connection->prepare($sql);
            $statement->execute($params);
            
        }catch(\Exception $e){
          throw $e;
        }
    
    }
    
    public function updatedesconciliacao($nrorg, $nrctbtemp, $idpart, $documento){
        // Query a ser executada.
        try{
            $sql = "UPDATE CTBTEMP SET IDCONCILIADO = 'N' WHERE IDPART = :IDPART AND NRCTBTEMP = :NRCTBTEMP AND NRORG =:NRORG AND CDDOCUCONTT = :CDDOCUCONTT" ;
        
            $params = array();
            $params['NRORG']   = $nrorg;
            $params['NRCTBTEMP']    = $nrctbtemp;
            $params['IDPART']   = $idpart;
            $params['CDDOCUCONTT']   = $documento;
            
            $statement = $this->connection->prepare($sql);
            $statement->execute($params);
            
        }catch(\Exception $e){
          throw $e;
        }
    
    }
    


}