<?php
namespace Teknisa\CTB\Factories;

use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class ctb53100DemonstracoesContabeisFactory{

	protected $entityManager;
	protected $reportService;
	protected $connection;
	protected $environment;

 public function __construct($entityManager, $reportService,$environment) {
		$this->entityManager  = $entityManager;
        $this->reportService = $reportService;
        $this->connection    = $entityManager->getConnection();
        $this->environment = $environment;
 	}
 	
 	public function callProcedureDemonstrativoCTBO($params) {
       try{
        $this->connection->beginTransaction();

        $procedure = new StoredProcedure($this->connection, 'DEMONSTRATIVO_CTBO');

        $procedure->addParam(new Param('P_CDEMPRESA',    Param::PARAM_INPUT, $params['CDEMPRESA'],   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDTIPODEMO',   Param::PARAM_INPUT, $params['CDTIPODEMO'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDSALDO',      Param::PARAM_INPUT, $params['IDSALDO'],     Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDDESCENCER',  Param::PARAM_INPUT, $params['IDDESCENCER'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAA',        Param::PARAM_INPUT, $params['DATAA'],       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAB',        Param::PARAM_INPUT, $params['DATAB'],       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAAINTERA',  Param::PARAM_INPUT, $params['DATAAINTERA'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATABINTERA',  Param::PARAM_INPUT, $params['DATABINTERA'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAAINTERB',  Param::PARAM_INPUT, $params['DATAAINTERB'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATABINTERB',  Param::PARAM_INPUT, $params['DATABINTERB'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRDEMO',       Param::PARAM_INPUT, $params['NRDEMO'],      Param::PARAM_TYPE_STR));
        
        $this->connection->commit();
        return $procedure->execute();
        
       }catch (\Exception $e){
            
           throw new \Exception($e->getMessage() );
           $this->connection->rollback();
       }
    }
    
  public function novoCodigoNT($counterName, $nrSeq = null, $qtd = 1){

   $nrorg = $this->environment->getNrOrgTrab();

 	
 	   try{
        $this->connection->beginTransaction();
        
        $procedure = new StoredProcedure($this->connection, 'NOVO_CODIGO_NT');

        $procedure->addParam(new Param('P_CONTADOR',     Param::PARAM_INPUT, $counterName, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_SEQUENCIAL',   Param::PARAM_OUTPUT, $nrSeq,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRORG',        Param::PARAM_INPUT, $nrorg,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_QTDE',         Param::PARAM_INPUT, $qtd,         Param::PARAM_TYPE_STR));

        $this->connection->commit();
        return $procedure->execute();
        
       }catch (\Exception $e){
            
           throw new \Exception($e->getMessage() );
           $this->connection->rollback();
       }
  }
  
  public function montaRelatorio($reportName, $parameterRow){
       $parameterRow["NRORG"] = $this->environment->getNrOrgTrab();
       return $this->reportService->createRemoteReport('BIRT', $reportName, $parameterRow, true);
  }
}