<?php

namespace Teknisa\CTB\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\CTB\Factories\Ctb22000RelatorioRazaoOficialFactory;

class Ctb22000RelatorioRazaoOficialServices {

    protected $entityManager;
    protected $execRazaoOficialFactory;
    
    /**
     * @param EntityManager $entityManager
     * @param Ctb22000RelatorioRazaoOficialFactory $execRazaoOficialFactory
     */
    public function __construct(EntityManager $entityManager,  Ctb22000RelatorioRazaoOficialFactory $execRazaoOficialFactory) {
        $this->entityManager = $entityManager;
        $this->Ctb22000RelatorioRazaoOficialFactory  = $execRazaoOficialFactory;
    }

    // /**
    //  * Gera Razão Oficial
    //  * @param $cdempresa
    //  * @param $cdcontini
    //  * @param $cdcontfin
    //  * @param $dtinicial
    //  * @param $dtfinal
    //  * @param $relesp
    //  */
    public function executaProcedureRazaoOficial($param){
        try {
            $cdEmpresa = $param["P_CDEMPRESA"];
            $dtIni = $param["P_DTINICIAL"];
            $dtFinal = $param["P_DTFINAL"];
            $dtContCtblIini = $param["P_CDCONTCTBLINI"];
            $dtContCtblFin = $param["P_CDCONTCTBLFIN"];
            $relesp =  $param["P_RELESP"];
            
            $nrrazao = $this->Ctb22000RelatorioRazaoOficialFactory->executaProcedureRazaoOficial(
                $cdEmpresa,$dtIni,$dtFinal,$dtContCtblIini,$dtContCtblFin,$relesp
            );
            
            return $nrrazao;
        }catch(\Exception $e) {
            throw $e;
        }
    }
}