/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ARVTIPOCARD                                              */
/* Tabela : ARVTIPOCARD                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 01/02/2005 - Henrique Dias Borges                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ARVTIPOCARD' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ARVTIPOCARD
GO

CREATE TRIGGER DTULTATU_ARVTIPOCARD
ON ARVTIPOCARD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ARVTIPOCARD', NULL, 'CDFILCENTPME='+ CDFILCENTPME+';'+'NRPASTATCARD='+NRPASTATCARD+';',GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ARVTIPOCARD
      SET DTULTATUARVT = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ARVTIPOCARD.CDFILCENTPME,0) = ISNULL(INSERTED.CDFILCENTPME,0)) AND
            (ISNULL(ARVTIPOCARD.NRPASTATCARD,0) = ISNULL(INSERTED.NRPASTATCARD,0))   ;
   END;
END;
GO
